module.exports.accept = function(params, schema, cb) {
  var errors = []
  var accepted = {}

  var addError = function(key, msg) {
    errors.push({field: key, message: msg})
  }

  Object.keys(schema).forEach(function(key){
    var option = schema[key]
    var value = params[key]
    var validate = (value && option.validation)

    if(validate && ! value.match(option.validation.regex)){
      addError(key, option.validation.message)
    }
    else if(option.required && ! value) addError(key, 'Missing field')
    else if(value) accepted[key] = value
  })

  var err = errors.length ? errors : null

  process.nextTick(function(){
    cb(err, accepted)  
  })
}